/*
**	ModemPanel.c
**
**	Editing panel for modem configuration
**
**	Copyright  1990-1993 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_MODEMINIT,GAD_MODEMEXIT,GAD_MODEMHANGUP,GAD_DIALPREFIX,GAD_DIALSUFFIX,
		GAD_NOCARRIER,GAD_NODIALTONE,GAD_CONNECT,GAD_VOICE,GAD_RING,GAD_BUSY,
		GAD_REDIALDELAY,GAD_DIALRETRIES,GAD_DIALTIMEOUT,GAD_REDIAL,GAD_AUTOBAUD,GAD_DROPDTR,
		GAD_USE,GAD_CANCEL,GAD_DEFAULT };

STATIC UBYTE * __saveds
ShowMinutes(struct Gadget *SomeGadget,WORD Level)
{
	STATIC UBYTE Buffer[15];

	SPrintf(Buffer,LocaleString(MSG_GLOBAL_SHOW_MINUTES_TXT),Level / 6,(Level % 6) * 10);

	return(Buffer);
}

STATIC UBYTE * __saveds
ShowSeconds(struct Gadget *SomeGadget,WORD Level)
{
	STATIC UBYTE Buffer[15];

	SPrintf(Buffer,LocaleString(MSG_GLOBAL_SHOW_MINUTES_TXT),Level / 60,Level % 60);

	return(Buffer);
}

STATIC struct Gadget *
CreateAllGadgets(struct Configuration *Config,struct Gadget **GadgetArray,struct Gadget **GadgetList,BYTE *Default)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	SZ_SizeSetup(Window -> WScreen,&UserFont,TRUE);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		SZ_AddLeftOffset(SZ_LeftOffsetDelta(MSG_MODEMPANEL_MODEM_INIT_STRING_GAD,MSG_MODEMPANEL_BUSY_STRING_GAD));

		SZ_ResetMaxWidth();

		SZ_UpdateMaxWidth(STRING_KIND,NULL,18,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_MODEM_INIT_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	79,
			GTST_String,	Config -> ModemConfig -> ModemInit,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_MODEM_EXIT_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	79,
			GTST_String,	Config -> ModemConfig -> ModemExit,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_MODEM_HANGUP_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	79,
			GTST_String,	Config -> ModemConfig -> ModemHangup,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_DIAL_PREFIX_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	79,
			GTST_String,	Config -> ModemConfig -> DialPrefix,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_DIAL_SUFFIX_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	79,
			GTST_String,	Config -> ModemConfig -> DialSuffix,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_NO_CARRIER_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	15,
			GTST_String,	Config -> ModemConfig -> NoCarrier,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_NO_DIALTONE_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	15,
			GTST_String,	Config -> ModemConfig -> NoDialTone,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_CONNECT_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	15,
			GTST_String,	Config -> ModemConfig -> Connect,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_VOICE_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	15,
			GTST_String,	Config -> ModemConfig -> Voice,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_RING_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	15,
			GTST_String,	Config -> ModemConfig -> Ring,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_BUSY_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	15,
			GTST_String,	Config -> ModemConfig -> Busy,
		TAG_DONE);

		SZ_SetWidth(90);

		SZ_AddLeftOffset(SZ_LeftOffsetDelta(MSG_MODEMPANEL_REDIAL_DELAY_GAD,MSG_MODEMPANEL_DROP_DTR_ON_HANGUP_GAD));

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_REDIAL_DELAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,
			SZ_NewColumn,		TRUE,

			GTSL_Min,		0,
			GTSL_Max,		360,
			GTSL_Level,		Config -> ModemConfig -> RedialDelay,
			GTSL_DispFunc,		ShowMinutes,
			GTSL_LevelFormat,	"%s",
			GTSL_MaxLevelLen,	11,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_DIAL_RETRIES_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GTSL_Min,		0,
			GTSL_Max,		100,
			GTSL_Level,		Config -> ModemConfig -> DialRetries,
			GTSL_LevelFormat,	"%3ld",
			GTSL_MaxLevelLen,	3,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_DIAL_TIMEOUT_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GTSL_Min,		0,
			GTSL_Max,		1800,
			GTSL_Level,		Config -> ModemConfig -> DialTimeout,
			GTSL_DispFunc,		ShowSeconds,
			GTSL_LevelFormat,	"%s",
			GTSL_MaxLevelLen,	11,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_REDIAL_AFTER_HANGUP_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> ModemConfig -> RedialAfterHangup,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_CONNECT_AUTO_BAUD_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> ModemConfig -> ConnectAutoBaud,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_DROP_DTR_ON_HANGUP_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> ModemConfig -> DropDTR,
		TAG_DONE);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_USE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_DEFAULT_GAD),0,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,
			SZ_AlignLeft,	TRUE,
			SZ_AlignBottom,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignRight,	TRUE,
		TAG_DONE);

		if(Default)
		{
			NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_DEFAULT_GAD);
			NewGadget . ng_GadgetID		= Counter;

			GadgetArray[Counter] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
				SZ_Adjust,	TRUE,
				SZ_AutoWidth,	TRUE,
				SZ_AlignCentre,	TRUE,
			TAG_DONE);
		}
	}

	return(Gadget);
}

BYTE
ModemPanel(struct Configuration *Config,BYTE *Default)
{
	struct Window	*PanelWindow;
	struct Gadget	*GadgetList = NULL;
	struct Gadget	*GadgetArray[GAD_DEFAULT + 1];

	SaveConfig(Config,PrivateConfig);

	if(CreateAllGadgets(Config,GadgetArray,&GadgetList,Default))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	GetScreenLeft(Window) + (GetScreenWidth(Window) - SZ_GetWindowWidth()) / 2,
			WA_Top,		GetScreenTop(Window) + (GetScreenHeight(Window) - SZ_GetWindowHeight())	/ 2,
			WA_Width,	SZ_GetWindowWidth(),
			WA_Height,	SZ_GetWindowHeight(),

			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Window -> WScreen,

			WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_ACTIVEWINDOW | IDCMP_CLOSEWINDOW | IDCMP_RAWKEY | IDCMP_VANILLAKEY | SLIDERIDCMP | CHECKBOXIDCMP | STRINGIDCMP | BUTTONIDCMP,

			WA_Title,	LocaleString(MSG_MODEMPANEL_MODEM_PREFERENCES_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 IClass,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			GuideContext(CONTEXT_MODEM);

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			SetSignal(0,SIG_BREAK);

			while(!Terminated)
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,Config);

					break;
				}

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					IClass	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&IClass,&Code);

					if(IClass == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(IClass == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(IClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,Config);

						Terminated = TRUE;
					}

					if(IClass == IDCMP_MOUSEMOVE)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_REDIALDELAY:

								Config -> ModemConfig -> RedialDelay = Code;
								break;

							case GAD_DIALRETRIES:

								Config -> ModemConfig -> DialRetries = Code;
								break;

							case GAD_DIALTIMEOUT:

								Config -> ModemConfig -> DialTimeout = Code;
								break;
						}
					}

					if(IClass == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_USE:

								Terminated = TRUE;

								strcpy(Config -> ModemConfig -> ModemInit,	SZ_GetString(GadgetArray[GAD_MODEMINIT]));
								strcpy(Config -> ModemConfig -> ModemExit,	SZ_GetString(GadgetArray[GAD_MODEMEXIT]));
								strcpy(Config -> ModemConfig -> ModemHangup,	SZ_GetString(GadgetArray[GAD_MODEMHANGUP]));
								strcpy(Config -> ModemConfig -> DialPrefix,	SZ_GetString(GadgetArray[GAD_DIALPREFIX]));
								strcpy(Config -> ModemConfig -> DialSuffix,	SZ_GetString(GadgetArray[GAD_DIALSUFFIX]));
								strcpy(Config -> ModemConfig -> NoCarrier,	SZ_GetString(GadgetArray[GAD_NOCARRIER]));
								strcpy(Config -> ModemConfig -> NoDialTone,	SZ_GetString(GadgetArray[GAD_NODIALTONE]));
								strcpy(Config -> ModemConfig -> Connect,	SZ_GetString(GadgetArray[GAD_CONNECT]));
								strcpy(Config -> ModemConfig -> Voice,		SZ_GetString(GadgetArray[GAD_VOICE]));
								strcpy(Config -> ModemConfig -> Ring,		SZ_GetString(GadgetArray[GAD_RING]));
								strcpy(Config -> ModemConfig -> Busy,		SZ_GetString(GadgetArray[GAD_BUSY]));

								Config -> ModemConfig -> RedialAfterHangup	= SZ_GetChecked(GadgetArray[GAD_REDIAL]);
								Config -> ModemConfig -> ConnectAutoBaud	= SZ_GetChecked(GadgetArray[GAD_AUTOBAUD]);
								Config -> ModemConfig -> DropDTR		= SZ_GetChecked(GadgetArray[GAD_DROPDTR]);

								break;

							case GAD_CANCEL:

								Terminated = TRUE;

								SaveConfig(PrivateConfig,Config);

								break;

							case GAD_DEFAULT:

								*Default	= TRUE;

								Terminated	= TRUE;

								break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}
	}

	FreeGadgets(GadgetList);

	return((BYTE)memcmp(PrivateConfig -> ModemConfig,Config -> ModemConfig,sizeof(struct ModemSettings)));
}
